Subject: Re: [PATCH] mtd: rawnand: marvell: select target before setting up data interface

From: Boris Brezillon <[email-masked]>
Date: Sat, 30 Mar 2019 19:20:36 +0100

On Mon, 25 Mar 2019 17:21:42 +0100
Daniel Mack <[email-masked]> wrote:

> Hi Miquel,
> 
> On 25/3/2019 10:09 AM, Miquel Raynal wrote:
> > Daniel Mack <[email-masked]> wrote on Fri, 22 Mar 2019 19:48:08
> > +0100:
> >   
> >> Hi Miquel,
> >>
> >> On 22/3/2019 9:30 AM, Miquel Raynal wrote:  
> >>> + Richard: this is fixes materials
> >>>
> >>> Daniel Mack <[email-masked]> wrote on Thu, 21 Mar 2019 22:20:10
> >>> +0100:
> >>>     
> >>>> Now that the nand drivers are responsible for selecting the target
> >>>> prior to hardware access, a call to marvell_nfc_select_target() is
> >>>> necessary from marvell_nfc_setup_data_interface().
> >>>>
> >>>> This is a regression introduced by commit b25251414f6e ("mtd:
> >>>> rawnand: marvell: Stop implementing ->select_chip()").
> >>>>
> >>>> Fixes: b25251414f6e ("mtd: rawnand: marvell: Stop implementing ->select_chip()")
> >>>> Cc: Boris Brezillon <[email-masked]>
> >>>> Cc: <[email-masked]>
> >>>> Signed-off-by: Daniel Mack <[email-masked]>
> >>>> ---
> >>>>  drivers/mtd/nand/raw/marvell_nand.c | 2 ++
> >>>>  1 file changed, 2 insertions(+)
> >>>>
> >>>> diff --git a/drivers/mtd/nand/raw/marvell_nand.c b/drivers/mtd/nand/raw/marvell_nand.c
> >>>> index 84283c6bb0ff..93abe5be8995 100644
> >>>> --- a/drivers/mtd/nand/raw/marvell_nand.c
> >>>> +++ b/drivers/mtd/nand/raw/marvell_nand.c
> >>>> @@ -2325,6 +2325,8 @@ static int marvell_nfc_setup_data_interface(struct nand_chip *chip, int chipnr,
> >>>>  	struct marvell_nfc_timings nfc_tmg;
> >>>>  	int read_delay;
> >>>>  
> >>>> +	marvell_nfc_select_target(chip, chip->cur_cs);
> >>>> +
> >>>>  	sdr = nand_get_sdr_timings(conf);
> >>>>  	if (IS_ERR(sdr))
> >>>>  		return PTR_ERR(sdr);    
> >>>
> >>> I had a short look yesterday and this is very likely to be the root
> >>> cause of the regression, thank you very much!    
> >>
> >> Yes it is, it fixes the regression I have reported.
> >>
> >> Do you want me to resend with that nit addressed you mentioned? My
> >> version works well, I know that much :)  
> > 
> > Yes please, resent with Boris' comment addressed and we'll be fine.  
> 
> I tried this now, and with 'chip->cur_cs' instead of 'chipnr', the
> regression is back. This function is invoked twice during boot, and in
> both cases, 'chip->cur_cs' is -1, while 'chipnr' is 0. The 2nd time this
> function is invoked, the 'selected_die' cache value is 0, so
> marvell_nfc_select_target() bails early, which seems to be a problem.
> 
> I can't quite make sense of that yet, all I know is that calling
> marvell_nfc_select_target() with -1 from
> marvell_nfc_setup_data_interface() makes the driver functional again. Hmm.

Can you try with the following diff applied?
--->8---
diff --git a/drivers/mtd/nand/raw/marvell_nand.c b/drivers/mtd/nand/raw/marvell_nand.c
index f38e5c1b87e4..e8eccf6afc8f 100644
--- a/drivers/mtd/nand/raw/marvell_nand.c
+++ b/drivers/mtd/nand/raw/marvell_nand.c
@@ -722,9 +722,6 @@ static void marvell_nfc_select_target(struct nand_chip *chip,
        struct marvell_nfc *nfc = to_marvell_nfc(chip->controller);
        u32 ndcr_generic;
 
-       if (chip == nfc->selected_chip && die_nr == marvell_nand->selected_die)
-               return;
-
        writel_relaxed(marvell_nand->ndtr0, nfc->regs + NDTR0);
        writel_relaxed(marvell_nand->ndtr1, nfc->regs + NDTR1);

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel